一篇文章带你弄懂Python异常传递和自定义异常

上一篇 / 下一篇  2021-06-21 16:51:01

  大家好,我是Go进阶者,今天给大家分享一些Python基础 (异常传递和自定义异常),上篇文章有说到:一篇文章带你弄懂Python异常简介和案例分析,这篇文章一起来看看异常其他知识吧~
  一、异常的传递
  1. try嵌套中
  import time 
   
  try: 
      f = open('test.txt') 
      try: 
          while True: 
              content = f.readline() 
              if len(content) == 0: 
                  break 
              time.sleep(2) 
      finally: 
          f.close() 
          print('关闭文件') 
  except : 
     print("没有这个文件") 
  finally: 
      print("最后的finally") 
   
  # 这是test.txt文件中读取到信息 
  运行结果:
  2. 函数嵌套调用中
  def test1(): 
       print("----test1-1----") 
       print(num) 
       print("----test1-2----") 
   
   
   def test2(): 
       print("----test2-1----") 
       test1() 
       print("----test2-2----") 
   
   
   def test3(): 
       try: 
           print("----test3-1----") 
           test1() 
           print("----test3-2----") 
       except Exception as result: 
           print("捕获到了异常,信息是:%s"%result) 
   
       print("----test3-2----") 
   
   
   test3() 
   print("------华丽的分割线-----") 
   test2() 
  运行结果:
  小总结:
  如果try嵌套,那么如果里面的try没有捕获到这个异常,那么外面的try会接收到这个异常,然后进行处理,如果外边的try依然没有捕获到,那么再进行传递。
  如果一个异常是在一个函数中产生的,例如函数A---->函数B---->函数C,而异常是在函数C中产生的,那么如果函数C中没有对这个异常进行处理,那么这个异常会传递到函数B中,如果函数B有异常处理那么就会按照函数B的处理方式进行执行;如果函数B也没有异常处理,那么这个异常会继续传递,以此类推。。。如果所有的函数都没有处理,那么此时就会进行异常的默认处理。
  二、抛出自定义的异常
  你可以用raise语句来引发一个异常。异常/错误对象必须有一个名字,且它们应是Error或Exception类的子类。
  下面是一个引发异常的例子:
  class ShortInputException(Exception): 
      '''自定义的异常类''' 
      def __init__(self, length, atleast): 
          #super().__init__() 
          self.length = length 
          self.atleast = atleast 
   
  def main(): 
      try: 
          s = input('请输入 --> ') 
          if len(s) < 3: 
              # raise引发一个你定义的异常 
              raise ShortInputException(len(s), 3) #自定义异常长度为3。 
               
      except ShortInputException as result:#x这个变量被绑定到了错误的实例 
         
          print('ShortInputException: 输入的长度是 %d,长度至少应是 %d'% (result.length, result.atleast)) 
      else: 
          print('没有异常发生.') 
   
  main() 
  运行结果:
  以上程序中,关于#super().init()代码的说明:
  这一行代码,可以调用也可以不调用,建议调用。
  因为__init__方法往往是用来对创建完的对象进行初始化工作,如果在子类中重写了父类的__init__方法,即意味着父类中的很多初始化工作没有做,这样就不保证程序的稳定了,所以在以后的开发中,如果重写了父类的__init__方法,最好是先调用父类的这个方法,然后再添加自己的功能。
  三、异常处理中抛出异常
  class Test(object): 
      def __init__(self, switch): 
          self.switch = switch #开关 
      def calc(self, a, b): 
          try: 
              return a/b 
          except Exception as result: 
              if self.switch: 
                  print("捕获开启,已经捕获到了异常,信息如下:") 
                  print(result) 
              else: 
                  #重新抛出这个异常,此时就不会被这个异常处理给捕获到,从而触发默认的异常处理 
                  raise 
   
  a = Test(True) 
   
  a.calc(11,0) 
   
  print("----------------------华丽的分割线----------------") 
   
  a.switch = False 
  a.calc(11,0) 
  运行结果:
  四、总结
  本文基于Python基础,详细的讲解了运行过程中遇到各种异常,应该采取什么样的处理方式,对各种异常提供有效的解决方案。通过一个个小项目实际操作,运行结果展示,能够更好的解决问题。希望可以帮助你更好的学习Python。

TAG: 软件开发 Python

 

评分:0

我来说两句

日历

« 2021-11-17  
 123456
78910111213
14151617181920
21222324252627
282930    

数据统计

  • 访问量: 34535
  • 日志数: 249
  • 建立时间: 2020-08-11
  • 更新时间: 2021-11-17

RSS订阅

Open Toolbar